clear all 
% close all

data_folder='E:\UTD\ArchiveNeuroImage\indivBeh';
root_folder = 'E:\UTD\ArchiveNeuroImage\models_NI\model_1_Bayes_BEAD_MonteCarlo';
addpath('..')
cd (data_folder)

load('fmri_sequence')
subdirs = dir('subj*');
n_subjects=length(subdirs);
n_iter=1000;                                                  

n_beads=3;
n_trials=71;
start_trial=1;
n_blocks=3;
tau=.1;

weight1=2/3;            %std
% weight2=1;         
% weight3=1;         

par_names{1}='Mode_Normal_distribution';
% par_names{2}='';
% par_names{3}='';
prmtn=length(par_names);

%% get subject list
for i=1:n_subjects 
    subj{i} = subdirs(i).name;
    likely1{i}=zeros(n_iter,n_blocks);
    likely2{i}=zeros(n_iter,n_blocks);
end

best_set=zeros(n_subjects,prmtn*2+2);

% cd (data_folder)

tic
for agent=1:n_subjects
    cd (data_folder)
    cd(subj{agent})
    filename= dir('bead*');
    clear data
    clear t_data
    clear real_choices
    clear cond2
    disp(agent);
    toc
    %load data series per each agent
    load(filename.name)
    cd ..
    
    %load real choice selections
    all_data{agent}=data;
    all_t_data{agent}=t_data;
    all_cond2{agent}=cond2;
    
    for iter=1:n_iter
        
        choice_selections=0;
        
        errors=zeros(n_iter,n_blocks);
        parameters{agent}(iter,1)=rand(1)*weight1+1/3;
        sigma1=parameters{agent}(iter,1);
        
%         values = normpdf(1:3,2,sigma1)/sum(normpdf(1:3,2,sigma1));
%         m=values(2);
%         s=values(1);
        m=sigma1;
        s=(1-sigma1)/2;
        beadp=[0 1 1
               1 0 1
               1 1 0]*s + eye(3)*m;
        
        for blocki=1:n_blocks %[optimal sample: 1 2 6
            jarp{blocki}=ones(n_trials,n_beads)/n_beads;
%             bead_disp=all_data{agent}{blocki}(:,5);
            bead_disp=beads{blocki};
            real_choices=all_data{agent}{blocki}(:,1);
            for triali=start_trial:length(bead_disp)
                
                if triali==start_trial
                    prob=jarp{blocki}(triali,:);
                else
                    prob=jarp{blocki}(triali-1,:);
                end
                %Bayesian update
                if bead_disp(triali)==1
                    den=sum(prob.*beadp(1,:));%prob(1)*beadp(1,1)+prob(2)*beadp(1,2)+prob(3)*beadp(1,3);
                elseif bead_disp(triali)==2
                    den=sum(prob.*beadp(2,:));%prob(1)*beadp(2,1)+prob(2)*beadp(2,2)+prob(3)*beadp(2,3);
                elseif bead_disp(triali)==3
                    den=sum(prob.*beadp(3,:));%prob(1)*beadp(3,1)+prob(2)*beadp(3,2)+prob(3)*beadp(3,3);
                end
                jarp{blocki}(triali,:)=(beadp(bead_disp(triali),:).*prob)/den;
%                 distro=softmaxselection(jarp{blocki}(triali,:), tau);
                distro=jarp{blocki}(triali,:);
                jarp{blocki}(triali,:)=max(0.05, jarp{blocki}(triali,:));
                jarp{blocki}(triali,:)=jarp{blocki}(triali,:)/sum(jarp{blocki}(triali,:));
%                 distro=softmaxselection(jarp{blocki}(triali,:), tau);


                %comparison
                if real_choices(triali)>0
                    choice_selections=choice_selections+1;
%                     if jarp{blocki}(triali,real_choices(triali))<.0001
%                         disp(log(jarp{blocki}(triali,real_choices(triali))))
%                     end

                    errors(iter,blocki)= 1-distro(real_choices(triali));
                    likely1{agent}(iter,blocki)=likely1{agent}(iter,blocki)+ errors(iter,blocki);
%                     likely2{agent}(iter,blocki)=likely2{agent}(iter,blocki)+ min(3, abs(log(distro(real_choices(triali)))));                    
                    likely2{agent}(iter,blocki)=likely2{agent}(iter,blocki)+ min(3, abs(log(distro(real_choices(triali)))));
                end
%                 jarp{blocki}(triali,:)=max(0.05, (beadp(bead_disp(triali),:).*prob)/den);
%                 jarp{blocki}(triali,:)=max(0.05, jarp{blocki}(triali,:));
                if max(jarp{blocki}(triali,:))==0.05
                    error ('check')
                end
%                 disp([bead_disp(triali) real_choices(triali)]);
%                 disp(jarp{blocki}(triali,:));
%                 disp(errors{agent}(iter,blocki));
%                 disp(likely1{agent}(iter,blocki));
%                 disp(likely2{agent}(iter,blocki));
%                 pause(1)
                
            end
        end
    end
    sum_likely1{agent}=sum(likely1{agent},2);
    sum_likely2{agent}=sum(likely2{agent},2);
    [val1, pos1]=min(sum_likely1{agent});
    [val2, pos2]=min(sum_likely2{agent});
    
    best_set(agent,1:prmtn)=parameters{agent}(pos1,:);
    best_set(agent,prmtn+1)=val1*100/choice_selections;
    best_set(agent,(prmtn+2):(prmtn*2+1))=parameters{agent}(pos2,:);
    best_set(agent,prmtn*2+2)=val2;
    
    disp(best_set(agent,:));
    cd (root_folder)
%     save('partial_bead_optimization', 'best_set');
end

mean_bs=mean(best_set(1:n_subjects,:))
std_bs=std(best_set(1:n_subjects,:))

% save('bead_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'all_t_data', 'all_cond2');

figure
scatter(ones(length(best_set(:,1)),1),best_set(:,1))
hold on
scatter(ones(length(best_set(:,1)),1)+1,best_set(:,3))
axis([0 3 0 1.1])


%%test for sample:p=[0.389 0.0033 0.25 0.0001 0.39 0.67 0.16]
