clear all
close all

data_folder='E:\UTD\ArchiveNeuroImage\indivBeh';
root_folder = 'E:\UTD\ArchiveNeuroImage\models_NI\model_1_Bayes_CARD_MonteCarlo';
addpath('..')
cd (data_folder)

load('fmri_sequence')
subdirs = dir('subj*');
n_subjects=length(subdirs);
n_iter=1000;

n_cards=3;
n_trials=71;
start_trial=1;
n_blocks=3;
tau=.1;

weight1=2/3;            %std
% weight2=2;          %std
% weight3=1;          %gamma

par_names{1}='Mode_Normal_distribution';
% par_names{2}='';
% par_names{3}='';
prmtn=length(par_names);

%% get subject list
for i=1:n_subjects
    subj{i} = subdirs(i).name;
    likely1{i}=zeros(n_iter,n_blocks);
    likely2{i}=zeros(n_iter,n_blocks);
    errors{i}=zeros(n_iter,n_blocks);
end

% for blocki=1:n_blocks
    best_set=zeros(n_subjects,prmtn*2+2);
% end

cd (data_folder)
filename= dir('card*');

tic
for agent=1:n_subjects
    cd(data_folder)
    cd(subj{agent})
    filename= dir('card*');
    clear data
    clear t_data
    clear real_choices
    clear outcomes
    clear cond3
    disp(agent);
    toc
    %load data series per each agent
    load(filename.name)
    cd ..
    
    %load real choice selections
    all_data{agent}=data;
    all_t_data{agent}=t_data;
    all_cond3{agent}=cond3;
    
    for iter=1:n_iter
        
        parameters{agent}(iter,1)=rand(1)*weight1+1/3; %iter/1000        
        sigma1=parameters{agent}(iter,1);
        
%         values = normpdf(1:3,2,sigma1)/sum(normpdf(1:3,2,sigma1));
%         m=values(2);
%         s=values(1);
        m1=sigma1;
        s1=(1-sigma1)/2;
        m2=s1/(m1*2+s1);%s1;
        s2=m1/(m1*2+s1);%(1-s1)/2;

        cardupdN100=[0 1 1
                     1 0 1
                     1 1 0]*s1 + eye(3)*m1;
        cardupdB100=[0 1 1
                     1 0 1
                     1 1 0]*s2 + eye(3)*m2;
        
        choice_selections=0;
        for blocki=1:n_blocks
            cardpN100{blocki}=ones(n_trials,n_cards)/n_cards;
%             cardpB{blocki}   =ones(n_trials,n_cards)/n_cards;
        end
        %starting probabilities
        
        for blocki=1:n_blocks
            outcomes    =all_data{agent}{blocki}(:,2);
            real_choices=all_data{agent}{blocki}(:,1);
            
            for triali=2:length(real_choices)
                %Bayesian update
                %                 main_outc=          outcomes{blocki}(triali-1)/110;
                %                 guess_outc=(110-outcomes{blocki}(triali-1))/110;
                prob=cardpN100{blocki}(triali-1,:);
                %Normal and Bimodal
                if real_choices(triali-1)==1
                    if outcomes(triali-1)==100
                        denN100=prob(1)*cardupdN100(1,1)+prob(2)*cardupdN100(1,2)+prob(3)*cardupdN100(1,3);
                    elseif  outcomes(triali-1)==10
                        denN100=prob(1)*cardupdB100(1,1)+prob(2)*cardupdB100(1,2)+prob(3)*cardupdB100(1,3);
                    elseif  outcomes(triali-1)==0
                        denN100=prob(1)*cardupdB100(1,1)+prob(2)*cardupdB100(1,2)+prob(3)*cardupdB100(1,3);
                    end
                elseif real_choices(triali-1)==2
                    if outcomes(triali-1)==100
                        denN100=prob(1)*cardupdN100(2,1)+prob(2)*cardupdN100(2,2)+prob(3)*cardupdN100(2,3);
                    elseif outcomes(triali-1)==10
                        denN100=prob(1)*cardupdB100(2,1)+prob(2)*cardupdB100(2,2)+prob(3)*cardupdB100(2,3);
                    elseif outcomes(triali-1)==0
                        denN100=prob(1)*cardupdB100(2,1)+prob(2)*cardupdB100(2,2)+prob(3)*cardupdB100(2,3);
                    end
                elseif real_choices(triali-1)==3
%                     denB=cardpB(triali-1,1)*cardupdB(3,1)+cardpB(triali-1,2)*cardupdB(3,2)+cardpB(triali-1,3)*cardupdB(3,3);
                    if outcomes(triali-1)==100
                        denN100=prob(1)*cardupdN100(3,1)+prob(2)*cardupdN100(3,2)+prob(3)*cardupdN100(3,3);
                    elseif outcomes(triali-1)==10
                        denN100=prob(1)*cardupdB100(3,1)+prob(2)*cardupdB100(3,2)+prob(3)*cardupdB100(3,3);
                    elseif outcomes(triali-1)==0
                        denN100=prob(1)*cardupdB100(3,1)+prob(2)*cardupdB100(3,2)+prob(3)*cardupdB100(3,3);
                    end
                end
                
                if  real_choices(triali-1)>0
                    if outcomes(triali-1)==100
                        cardpN100{blocki}(triali,:)=(cardupdN100(real_choices(triali-1),:).*cardpN100{blocki}(triali-1,:))/denN100;
                    else
                        cardpN100{blocki}(triali,:)=(cardupdB100(real_choices(triali-1),:).*cardpN100{blocki}(triali-1,:))/denN100;
                    end
                else
                    cardpN100{blocki}(triali,:)=(prob +ones(1,3)/3)/2;
                end
                
%                 distro=softmaxselection(cardpN100{blocki}(triali,:), tau);
                distro=cardpN100{blocki}(triali,:);

                cardpN100{blocki}(triali,:)=max(0.05, cardpN100{blocki}(triali,:));
                cardpN100{blocki}(triali,:)=cardpN100{blocki}(triali,:)/sum(cardpN100{blocki}(triali,:));

                
                %comparison
                if real_choices(triali)>0
                    errors{agent}(iter,blocki)= 1-distro(real_choices(triali));
                    likely1{agent}(iter,blocki)=likely1{agent}(iter,blocki)+ errors{agent}(iter,blocki);
%                     likely2{agent}(iter,blocki)=likely2{agent}(iter,blocki)+ abs(log(distro(real_choices(triali))));
                    likely2{agent}(iter,blocki)=likely2{agent}(iter, blocki)+ min(3, abs(log(distro(real_choices(triali)))));

                    choice_selections=choice_selections+1;
                end
%                 cardpN100{blocki}(triali,:)=max(0.05, cardpN100{blocki}(triali,:));
                if max(cardpN100{blocki}(triali,:))==0.05
                    error ('check')
                end
%                 cardpN100{blocki}(triali,:)=max(0.05, cardpN100{blocki}(triali,:));

%                 disp([real_choices(triali-1) outcomes(triali-1)]);
%                 disp(cardpN100{blocki}(triali,:));
%                 pause(1)
                
            end
        end
    end

    sum_likely1{agent}=sum(likely1{agent},2);
    sum_likely2{agent}=sum(likely2{agent},2);
    [val1, pos1]=min(sum_likely1{agent});
    [val2, pos2]=min(sum_likely2{agent});
    
    best_set(agent,1:prmtn)=parameters{agent}(pos1,:);
    best_set(agent,prmtn+1)=val1*100/choice_selections;
    best_set(agent,(prmtn+2):(prmtn*2+1))=parameters{agent}(pos2,:);
    best_set(agent,prmtn*2+2)=val2;
    
%     disp(best_set(agent,:));
    cd (root_folder)
%     save('partial_card_optimization', 'best_set');
end

% for blocki=1:n_blocks
mean_bs=mean(best_set(1:n_subjects,:))
std_bs=std(best_set(1:n_subjects,:))
% end

% save('card_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'all_t_data', 'all_cond3');

figure
hold on
% for blocki=1:3
scatter(ones(length(best_set(:,1)),1),best_set(:,1))
scatter(ones(length(best_set(:,1)),1)+1,best_set(:,3))
% end
hold off
axis([0 3 0 1.1])
