clear all 
% close all

data_folder='E:\UTD\ArchiveNeuroImage\indivBeh';
root_folder = 'E:\UTD\ArchiveNeuroImage\models_NI\model_2_Bayes_BEAD_maxlikelihood';
addpath('..')
cd (data_folder)

load('fmri_sequence')
subdirs = dir('subj*');
n_subjects=length(subdirs);

n_beads=3;
n_trials=71;
start_trial=1;
n_blocks=3;

weight1=2;            %std
% weight2=1;         
% weight3=1;         

par_names{1}='Mode_Normal_distribution';
% par_names{2}='';
% par_names{3}='';
prmtn=length(par_names);

%% get subject list
for i=1:n_subjects 
    subj{i} = subdirs(i).name;
%     likely1{i}=zeros(n_iter,n_blocks);
%     likely2{i}=zeros(n_iter,n_blocks);
%     errors{i}=zeros(n_iter,n_blocks);
end

best_set=zeros(n_subjects,prmtn*2+2);

% cd (data_folder)

tic
for agent=1:n_subjects
    cd (data_folder)
    cd(subj{agent})
    filename= dir('bead*');
    clear data
    clear real_choices
    disp(agent);
    toc
    %load data series per each agent
    load(filename.name)
    cd(root_folder)
    
    %load real choice selections
    all_data{agent}=data;
    all_t_data{agent}=t_data;
    
   
    [sigmalin,fvallin] = fminunc(@(sigma1) bayes_function_lin(sigma1, data, beads), 0.9);
%     likely2(agent)= bayes_function_log(sigma1);
    [sigmalog,fvalog] = fminunc(@(sigma1) bayes_function_log(sigma1, data, beads), 0.9);
        
    best_set(agent,1:prmtn)=sigmalin;
    best_set(agent,prmtn+1)=fvallin;
    best_set(agent,(prmtn+2):(prmtn*2+1))=sigmalog;
    best_set(agent,prmtn*2+2)=fvalog;
    
    disp(best_set(agent,:));
%     cd (root_folder)
%     save('partial_bead_optimization', 'best_set');
end

mean_bs=mean(best_set(1:n_subjects,:))
std_bs=std(best_set(1:n_subjects,:))

% save('bead_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'errors');
% save('scz_bead_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'errors');
% save('bead_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'all_t_data');

figure
scatter(ones(length(best_set(:,1)),1),best_set(:,1))
hold on
scatter(ones(length(best_set(:,1)),1)+1,best_set(:,3))
axis([0 3 0 1.2])


%%test for sample:p=[0.389 0.0033 0.25 0.0001 0.39 0.67 0.16]
