clear all 
% close all

data_folder='E:\UTD\ArchiveNeuroImage\indivBeh';
root_folder = 'E:\UTD\ArchiveNeuroImage\models_NI\model_4_RL_BEAD_maxlikelihood';
addpath('..')
cd (data_folder)

load('fmri_sequence')
subdirs = dir('subj*');
n_subjects=length(subdirs);

n_beads=3;
n_trials=71;
start_trial=1;
n_blocks=3;

% weight1=1;            %std
% weight2=1;         
% weight3=1;         

par_names{1}='learning rate';
par_names{2}='risk aversion';
% par_names{3}='Tau';
% par_names{3}='';
prmtn=length(par_names);

%% get subject list
for i=1:n_subjects 
    subj{i} = subdirs(i).name;
%     likely1{i}=zeros(n_iter,n_blocks);
%     likely2{i}=zeros(n_iter,n_blocks);
%     errors{i}=zeros(n_iter,n_blocks);
end

best_set=zeros(n_subjects,prmtn*2+2);

% cd (data_folder)

tic
for agent=1:n_subjects
    cd (data_folder)
    cd(subj{agent})
    filename= dir('bead*');
    clear data
    clear real_choices
    disp(agent);
    toc
    %load data series per each agent
    load(filename.name)
    cd(root_folder)
    
    %load real choice selections
    all_data{agent}=data;
    all_t_data{agent}=t_data;
    all_cond2{agent}=cond2;
    
%     [x, cost, ~, ~, ~, ~] = fminunc(@(x) FS_RW(offer,resp,x), X0(s,:), options);
    
%     likely1(agent)= bayes_function_lin(sigma1);
    [parmlin,fvalin] = fminunc(@(prm) RL_function_lin(prm(1), prm(2), all_data{agent}, beads), [1 1]);
%     likely2(agent)= bayes_function_log(sigma1);
    [parmlog,fvalog] = fminunc(@(prm) RL_function_log(prm(1), prm(2), all_data{agent}, beads), [1 1]);
    
%     [val1, pos1]=min(sum_likely1{agent});
%     [val2, pos2]=min(sum_likely2{agent});
    
    best_set(agent,1:prmtn)=parmlin;
    best_set(agent,prmtn+1)=fvalin;
    best_set(agent,(prmtn+2):(prmtn*2+1))=parmlog;
    best_set(agent,prmtn*2+2)=fvalog;
    
    disp(best_set(agent,:));
%     cd (root_folder)
%     save('partial_bead_optimization', 'best_set');
%     save('partial_bead_optimization', 'best_set', 'all_data', 'all_t_data');
end

mean_bs=mean(best_set(1:n_subjects,:))
std_bs=std(best_set(1:n_subjects,:))

% save('bead_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'all_t_data', 'all_cond2');

figure
hold on
scatter(ones(length(best_set(:,1)),1),best_set(:,1))
scatter(ones(length(best_set(:,1)),1)+0.1,best_set(:,2))
scatter(ones(length(best_set(:,1)),1)+1,best_set(:,4))
scatter(ones(length(best_set(:,1)),1)+1.1,best_set(:,5))
axis([0 3 0 max(best_set(:,2))])


%%test for sample:p=[0.389 0.0033 0.25 0.0001 0.39 0.67 0.16]
