clear all
% close all

data_folder='E:\UTD\ArchiveNeuroImage\indivBeh';
root_folder = 'E:\UTD\ArchiveNeuroImage\models_NI\model_4_RL_CARD_maxlikelihood';
addpath('..')
cd (data_folder)

load('fmri_sequence')
subdirs = dir('subj*');
n_subjects=length(subdirs);

n_cards=3;
n_trials=71;
start_trial=1;
n_blocks=3;

% weight1=0.8;            %std
% weight2=2;          %std
% weight3=1;          %gamma

par_names{1}='learning rate';
par_names{2}='risk aversion';
% par_names{3}='Tau';
% par_names{3}='';
prmtn=length(par_names);

%% get subject list
for i=1:n_subjects
    subj{i} = subdirs(i).name;
end

best_set=zeros(n_subjects,prmtn*2+2);

cd (data_folder)
filename= dir('card*');

tic
for agent=1:n_subjects
    cd(data_folder)
    cd(subj{agent})
    filename= dir('card*');
    clear data
    clear t_data
    clear real_choices
    clear outcomes
    disp(agent);
    toc
    %load data series per each agent
    load(filename.name)
    cd(root_folder)
    
    %load real choice selections
    all_data{agent}=data;
    all_t_data{agent}=t_data;
    all_cond3{agent}=cond3;
    
    [parmlin,fvallin] = fminunc(@(prm) RL_function_lin(prm(1), prm(2), data), [0.1, 0.1]);
    [parmlog,fvalog]  = fminunc(@(prm) RL_function_log(prm(1), prm(2), data), [0.1, 0.1]);
%     delete('partial_card_optimization.mat')
    
%     [val1, pos1]=min(sum_likely1{agent});
%     [val2, pos2]=min(sum_likely2{agent});
    
    best_set(agent,1:prmtn)=parmlin;
    best_set(agent,prmtn+1)=fvallin;
    best_set(agent,(prmtn+2):(prmtn*2+1))=parmlog;
    best_set(agent,prmtn*2+2)=fvalog;
    
    disp(best_set(agent,:));
%     cd (root_folder)
%     save('partial_bead_optimization', 'best_set');
%     save('partial_card_optimization', 'best_set', 'par_names', 'all_data', 'all_t_data');
end

mean_bs=mean(best_set(1:n_subjects,:))
std_bs=std(best_set(1:n_subjects,:))

% save('card_optimization', 'best_set', 'mean_bs', 'std_bs', 'par_names', 'all_data', 'all_t_data', 'all_cond3');

figure
hold on
scatter(ones(length(best_set(:,1)),1),best_set(:,1))
scatter(ones(length(best_set(:,1)),1)+0.1,best_set(:,2))
% scatter(ones(length(best_set(:,1)),1)+0.2,best_set(:,3))
scatter(ones(length(best_set(:,1)),1)+1,best_set(:,4))
scatter(ones(length(best_set(:,1)),1)+1.1,best_set(:,5))
% scatter(ones(length(best_set(:,1)),1)+1.2,best_set(:,7))
hold off
% axis([0 3 0 max(best_set(:,2))])
